from discord import ButtonStyle, ui, Interaction
from redbot.core import commands

from aurora.configuration.embed import addrole
from aurora.utilities.config import config

class Addrole(ui.View):
    def __init__(self, ctx: commands.Context):
        super().__init__()
        self.ctx = ctx

    @ui.select(cls=ui.RoleSelect, placeholder="Select a role")
    async def addrole_select(self, interaction: Interaction, select: ui.RoleSelect):
        if not interaction.user.guild_permissions.manage_guild and not interaction.user.guild_permissions.administrator:
            await interaction.response.send_message("You must have the manage guild permission to add roles to the addrole whitelist.", ephemeral=True)
            return
        await interaction.response.defer()
        addrole_whitelist: list = await config.guild(self.ctx.guild).addrole_whitelist()
        if select.values[0].id in addrole_whitelist:
            addrole_whitelist.remove(select.values[0].id)
        else:
            addrole_whitelist.append(select.values[0].id)
        await config.guild(self.ctx.guild).addrole_whitelist.set(addrole_whitelist)
        await interaction.message.edit(embed=await addrole(self.ctx), view=Addrole(self.ctx))

    @ui.button(label="Close", style=ButtonStyle.red)
    async def close(self, interaction: Interaction, button: ui.Button): # pylint: disable=unused-argument
        await interaction.message.delete()
